--[[

    TODO:   

        Priority to dos:

            bug: buttons squish and overlap if console is too narrow
            createButtonBar(location,colors)
            createButton(label,action,buttonBar,colors)-- location = inline or button-bar
            removeButton(button)
            removeButtonBar(buttonBar)
            .buttonBars(t,b,r,l)
                dimensions (when multi-line)
                set dimensions and draw in draw before content
                subtract from visible area/clip area

            touch logic is still unreliable, requires better structure

            make all setters return self, so they can be chained

            improve palette to make sure there is adequate contrast and stay within theme, add more colors for gray text/highlight colors

            getNestedFilterFunction() to allow And/or logic
            Constant (like print constants) to declare AND, OR or NOT logic within filter parameters

            Refactor handleTouch (just to make it more logical)
                First determine type of touch (don't bother if already determined)
                Then call method to do that type
                    hidden
                    minimized
                    buttons
                    tapping
                    resizing
                    dragging
                    scrolling
                two touches
                    pinch-zoom-scroll
    
            optimize drawing as much as possible (stop when drawing is above clip area, and start from visible area when nothing has changed; font size, offset, dimensions, content... need self.rebuild = true in appropriate setters, and use those setters internally)

        Later or optional to dos:                

            option to add pending lines to copy/save?

            create class with methods to create a theme given one or two colors and a style ("mist","bold",etc.)
                Maybe more colors (tweak the colors)... maybe separate class...
    
            Refactor code into multiple files?  Constants, Globals, Init, Setters, Logic, Touch, Draw

            Odd bug: If you drag too quickly, it can stop dragging... iOS or Codea touch issue?
                Touches are not being destroyed properly?  This might be fixed now, but needs more extensive testing
            
            Change terminology
                    minimize/maximize/fullscreen/hide/show
                    collapse/expand/maximize/close/open
                    minify/maxify/fullscreen/hide/show
    
            Add type checking to setters
                    
            Write timestamp/line num separate from wrapped content
            
            Let developers specify colors for specific words or patterns
                    Easier with no-wrap, very hard with wrap
                        Do no-wrap version first (disallow/error-abort if wrapping, or force no wrap if coloring a line by word)
            
            Recompute button sizes to fit without overlapping title?
            
            Draw optimization fails because it needs to know about translations... fix this
            
            pasteAndExecute(command or lua) button (optional, or 5 clicks to show)
            
            tile() command to automatically tile all consoles in a grid
    
--]]
    
function setup()
    viewer.mode = FULLSCREEN
end

function draw()
    
    testFilters()
    
    background(color(30,10,10,255))
    
    --DevConsole.drawAll()--[[
    
    DevConsole.testAll(
        3,
        {   -- Various random defaults
            testGetThemes(), 
            wrapLogLines={false,true},
            tabName="MySave",
            toEmptyTabOnly=true,
            appendToTab=true,
            minimizedLabel={"A","B","C","😍","📵","💀","👁","🐸","🐵","🐞","🦖","🍄","🌞","🌚","🌈","🚀","🗿"}
        },
        0.5 -- Delay 1/2 second between each random log line
    )--]]
    
end

function touched(touch)
    if DevConsole.touchedAny(touch) then return end
end
